const mailService = require('pubsweet-component-mail-service')
const logger = require('@pubsweet/logger')

module.exports = {
  addAuthor: async (
    collection,
    user,
    res,
    url,
    isSubmitting,
    isCorresponding,
  ) => {
    collection.authors = collection.authors || []
    const author = {
      userId: user.id,
      firstName: user.firstName || '',
      lastName: user.lastName || '',
      email: user.email,
      title: user.title || '',
      affiliation: user.affiliation || '',
      isSubmitting,
      isCorresponding,
    }
    collection.authors.push(author)
    await collection.save()
    if (collection.owners.includes(user.id)) {
      return res.status(200).json(user)
    }
    try {
      mailService.sendSimpleEmail({
        toEmail: user.email,
        user,
        emailType: 'add-author',
        dashboardUrl: url,
      })

      return res.status(200).json(user)
    } catch (e) {
      logger.error(e)
      return res.status(500).json({ error: 'Email could not be sent.' })
    }
  },
}
